#!/usr/bin/perl

# 東京電力6月20日以降対応版
# thanks http://blog.livedoor.jp/petykin/archives/1409104.html
# ただし、uniq, sort の部分は入っていません。
# Spreadsheet::ParseExcel が必要です。

use strict;
use warnings;
use Jcode;

my $baseurl="http://www.tepco.co.jp/keikakuteiden/images/";
my $wget="wget";
my @cnv_files = ("tochigi01","ibaraki01","gunma01","chiba01","kanagawa01"
			   ,"tokyo01","saitama01","yamanashi01","numazu01");
GetExcel($baseurl,@cnv_files);
Excel2CSV(@cnv_files);

sub GetExcel {
	my $urlbase=shift;
	my @files=@_;
	my $extention="xls";
	foreach(@files) {
		unlink("$_.$extention");
		&shell("wget $urlbase$_.$extention");
	}
}
sub shell {
	my($shell)=@_;
	my $buf;
	open(PIPE,"$shell|");
	foreach(<PIPE>) {
		chomp;
		$buf.=$_;
	}
	close(PIPE);
	$buf;
}

sub Excel2CSV {
	use Spreadsheet::ParseExcel;
	use Spreadsheet::ParseExcel::FmtJapan;
	my @files = @_;
	my $excel = Spreadsheet::ParseExcel->new;
	my $fmt = Spreadsheet::ParseExcel::FmtJapan->new(Code=>'sjis');
	open(OUT,"> all.tmp");
	foreach my $path (@files) {
		print "Parse $path.xls\n";
		my $book = $excel->Parse($path.".xls", $fmt);
		my $sheet = $book->{"Worksheet"}[0];
		my $maxRow = $sheet->{"MaxRow"};
		my $maxCol = $sheet->{"MaxCol"};

		for(my $row=3; $row<=$maxRow; $row++) {
			my @rows;
			my $rowdata="";
			for(my $col=0; $col<=$maxCol; $col++) {
				my $cell = $sheet->{"Cells"}[$row][$col];
				my $val = "";
				if ($cell) {
					$val = $cell->Value;
				}
				$rowdata.="$val\t";
			}
			$rowdata=~s/\t$//g;
			if($rowdata!~/都県/ && $rowdata!~/追加/ && $rowdata!~/異なる/ && $rowdata!~/現時点/) {
				print OUT "$rowdata\n";
			}
		}
	}
	close(OUT);
	open(OUT,"> all2.txt");
	open(IN,"all.tmp");
	foreach (<IN>) {
		chomp;
		my $data=Jcode->new($_)->utf8;
		my($pref,$city,$cho,$chome,$grp,$sub)=split(/\t/,$data);
		$grp=~s/１/1/g;
		$grp=~s/２/2/g;
		$grp=~s/３/3/g;
		$grp=~s/４/4/g;
		$grp=~s/５/5/g;
		$sub=~s/Ａ/A/g;
		$sub=~s/Ｂ/B/g;
		$sub=~s/Ｃ/C/g;
		$sub=~s/Ｄ/D/g;
		$sub=~s/Ｅ/E/g;
		print OUT "$pref\t$city\t$cho$chome\t$grp\t$sub\n";
	}
	close(IN);
	close(OUT);
	unlink("all.tmp");
}
